<!DOCTYPE html>
<html>
<head>
	<title>Exam 2</title>
	<style>
		.active {
			color: red;
		}

        .children {
            background: #ccc;
        }
	</style>
</head>
<body>
	<div id="app">
		<h3>{{ message }}</h3>
		<send-message inline-template>
			<div>
				<div class="flash-message" v-if='isDeleted' v-bind:class="{active: isDeleted}">
					Nội dung bị xóa là: {{ deleteMessage }}
				</div>

    			<textarea v-model='message'></textarea>
    			<button @click='send'>Send</button>

                <div class="children">
    			<receive-message :messages="messages"
                    v-on:notify-delete="getNotifyDelete">         
                </receive-message>
                </div>
    		</div>
		</send-message>
	</div>


	<script src="https://cdn.jsdelivr.net/npm/vue"></script>
    <script>
    	Vue.component('send-message', {
    		data() {
    			return {
    				message: '',
    				isDeleted: false,
                    messages: []
    			}
    		},
    		methods: {
    			send() {
                    this.messages.push({content: this.message})
                    this.message = '';
    			},
    			getNotifyDelete(message) {
    				this.isDeleted = true;
    				this.deleteMessage = message.content
    			}
    		},
    	})


     	Vue.component('receive-message', {
            props: {
                messages: {
                    type: Array,
                    default: () => {
                        return []
                    }
                }
            },
    		data() {
    			return {
    				childrenMessages: this.messages,
    			}
    		},
    		methods: {
    			deleteMessage(index, message) {
    				this.messages.splice(index, 1)
    				this.$emit('notify-delete', message);
    			}
    		},
    		template: `<div>
    			<h3>Chat</h3>
    			<p v-for='(message, key) in childrenMessages'>
    				{{ message.content }}
    				<a href='#' style="color: red;" 
    					@click='deleteMessage(key, message)'>Delete</a>
    			</p>
    		</div>`,
    	})


    	new Vue({
    		el: '#app',
    		data: {
    			message: 'Học Vue JS',
    			menuTops: [
    				{
    					id: 1,
    					name: 'Home'
    				},
    				{
    					id: 2,
    					name: 'About'
    				},
    				{
    					id: 3,
    					name: 'Services'
    				},
    				{
    					id: 4,
    					name: 'Products'
    				},
    			],
    			menuRights: [
    				{
    					id: 1,
    					name: 'Laptop'
    				},
    				{
    					id: 2,
    					name: 'Desktop'
    				},
    				{
    					id: 3,
    					name: 'Mobile'
    				},
    				{
    					id: 4,
    					name: 'Camera'
    				},
    				{
    					id: 5,
    					name: 'Printer'
    				},
    			],
    		}
    	})
    </script>
</body>
</html>